import React from "react";
declare type Props = {
    webKakaoKey: string;
    whitelistedDomain: string;
    onShareFailure?: () => void;
};
export declare type LinkObject = {
    webUrl?: string;
    mobileWebUrl?: string;
    androidExecParams?: string;
    iosExecParams?: string;
};
export declare type DefaultTemplate = {
    objectType: "text";
    text: string;
    link: LinkObject;
    buttonTitle?: string;
    buttons?: Array<{
        title: string;
        link: LinkObject;
    }>;
    callback?: () => void;
    serverCallbackArgs?: object | string;
};
export declare type CustomTemplate = {
    templateId: number;
    templateArgs?: Record<string, string>;
    installTalk?: boolean;
};
export default class KakaoLink extends React.PureComponent<Props> {
    private webview;
    private get source();
    sendDefault: (template?: DefaultTemplate) => void;
    sendCustom: (template: CustomTemplate) => void;
    private handleScheme;
    render(): JSX.Element;
}
export {};
