var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from "react";
import { StyleSheet, Linking } from "react-native";
import WebView from "react-native-webview";
var KakaoLink = /** @class */ (function (_super) {
    __extends(KakaoLink, _super);
    function KakaoLink() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.webview = React.createRef();
        _this.sendDefault = function (template) {
            var _a;
            var script = "window.Kakao.Link.sendDefault(" + JSON.stringify(template) + "); true;";
            (_a = _this.webview.current) === null || _a === void 0 ? void 0 : _a.injectJavaScript(script);
        };
        _this.sendCustom = function (template) {
            var _a;
            var script = "window.Kakao.Link.sendCustom(" + JSON.stringify(template) + "); true;";
            (_a = _this.webview.current) === null || _a === void 0 ? void 0 : _a.injectJavaScript(script);
        };
        _this.handleScheme = function (_a) {
            var url = _a.url;
            var link = url.startsWith("intent:") ? url.replace("intent:", "") : url;
            if (link.startsWith("kakaolink://")) {
                Linking.openURL(link).catch(_this.props.onShareFailure);
                return false;
            }
            return true;
        };
        return _this;
    }
    Object.defineProperty(KakaoLink.prototype, "source", {
        get: function () {
            return {
                baseUrl: this.props.whitelistedDomain,
                html: "\n<html>\n    <meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">\n    <script src=\"https://developers.kakao.com/sdk/js/kakao.js\"></script>\n    <script>\n        window.Kakao.init(\"" + this.props.webKakaoKey + "\");\n    </script>\n</html>"
            };
        },
        enumerable: false,
        configurable: true
    });
    KakaoLink.prototype.render = function () {
        return (<WebView originWhitelist={["*"]} onShouldStartLoadWithRequest={this.handleScheme} style={styles.webview} ref={this.webview} allowsInlineMediaPlayback={false} source={this.source}/>);
    };
    return KakaoLink;
}(React.PureComponent));
export default KakaoLink;
var styles = StyleSheet.create({
    webview: { flex: 0, width: 0, height: 0, opacity: 0 }
});
